import createComponent from '../../../dist/redom.js';

const ENTER_KEY = 13;
const ESCAPE_KEY = 27;

export default createComponent({
  create() {
  },
  view() {
    return (
      <header class="header">
        <h1>todos</h1>
        <input ref="input" class="new-todo" placeholder="What needs to be done?" autofocus />
      </header>
    );
  },
  render(container) {
    const node = this.view();
    this.refs.input.addEventListener('keyup', this._onChange);
    container.appendChild(node);
    return node;
  }
}, {
  _onChange(e) {
    const target = e.target;
    if (e.which === ENTER_KEY) {
      if (target.value.trim() === '') {
        return;
      }
      this.trigger('create', target.value);
      target.value = '';
    } else if (e.which === ESCAPE_KEY) {
      target.value = '';
    }
  }
});
