/*
 The dream here is to have simple library that:
 1. Uses DOM and utilize DOM state
 2. Provide easy way to access references to DOM elements
 3. Helps to make some kind of reusable components
 485. Help me to learn Javascript

 TODO:
 * how to use DOM state in nice manner?
 * since it looks ugly and usage sucks answer a question:
   - how to make it better?
 * ... do it
*/
import createEmitter from './emitter.js';

const REF = 'ref';

function isNode(el) {
  return el && el.nodeName && el.nodeType;
}

/*
 * TODO: child default to []?
 */
function h(tag, attr = null, child = null, references = this.refs) {
  const refs = references;
  const ret = document.createElement(tag);
  if (attr !== null) {
    Object.getOwnPropertyNames(attr).map((k) => {
      if (k === REF) {
        refs[attr[k]] = ret;
        return;
      }
      ret.setAttribute(k, attr[k]);
    });
  }
  if (Array.isArray(child)) {
    child.map((el) => {
      if (typeof el === 'string') {
        ret.appendChild(document.createTextNode(el));
      }
      if (isNode(el)) {
        ret.appendChild(el);
      }
    });
  } else if (child !== null) {
    throw Error('Unexpected child element' + JSON.stringify(child));
  }

  return ret;
}

function refText(label, ref) {
  const node = document.createTextNode(label);
  this.refs[ref] = node;
  return node;
}

/*
 * Component:
 * on, off, trigger - from emitter
 * create, destroy, _h, _t - for proto
 * own API
 */
const proto = {
  _t: refText,
  _h: h,
  create() {},
  destroy() {
    // Remove all event listeners
    this.removeAll();
    if (this._destroy) {
      this._destroy();
    }
    this.refs = {};
  }
};

export default function createComponent(methods, events) {
  return function (...args) {
    const instance = Object.assign(createEmitter(), proto, methods);
    if (events !== undefined && events !== null) {
      const e = Object.getOwnPropertyNames(events);
      e.forEach((p) => {
        const func = events[p];
        if (typeof func === 'function') {
          instance[p] = func.bind(instance);
        }
      });
    }

    instance.refs = {};
    instance.create(...args);
    return instance;
  };
}
